
def update_redshift_table(df):
                      
     import pandas as pd
     import os
     import importlib
     
     s3_filename_for_update = "s3://zeemee-data-team-files/zeemee_py/redshift_tables/additional_fields_all_partner_data.csv"
     s3_file_name = s3_filename_for_update.split("/")[-1]
     
     #ensuring columns are always arranged correctly
     column_list = [
                    'org_id',
                    'org_name',
                    'entry_year',
                    'student_type',
                    'entry_term',
                    'inquired_comm_first_gen',
                    'applied_comm_first_gen_',
                    'app_complete_comm_first_gen',
                    'accepted_comm_first_gen',
                    'committed_comm_first_gen',
                    'enrolled_comm_first_gen',
                    'inquired_not_in_comm_first_gen',
                    'applied_not_in_comm_first_gen_',
                    'app_complete_not_in_comm_first_gen',
                    'accepted_not_in_comm_first_gen',
                    'committed_not_in_comm_first_gen',
                    'enrolled_not_in_comm_first_gen',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_first_gen',
                    'commitment_rate_not_in_comm_in_comm_as_dep_first_gen',
                    'commitment_rate_never_in_community_first_gen',
                    'melt_rate_never_in_community_first_gen',
                    'melt_rate_in_comm_all_first_gen',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_first_gen',
                    'yield_rate_not_in_comm_in_comm_as_deposit_first_gen',
                    'yield_rate_never_in_community_first_gen',
                    'app_rate_in_comm_in_comm_prior_to_app_first_gen',
                    'app_rate_not_in_comm_in_comm_as_app_or_after_first_gen',
                    'app_rate_never_in_community_first_gen',
                    'inquired_comm_campus_visit',
                    'applied_comm_campus_visit',
                    'app_complete_comm_campus_visit',
                    'accepted_comm_campus_visit',
                    'committed_comm_campus_visit',
                    'enrolled_comm_campus_visit',
                    'inquired_not_in_comm_campus_visit',
                    'applied_not_in_comm_campus_visit',
                    'app_complete_not_in_comm_campus_visit',
                    'accepted_not_in_comm_campus_visit',
                    'committed_not_in_comm_campus_visit',
                    'enrolled_not_in_comm_campus_visit',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_campus_visit',
                    'commitment_rate_not_in_comm_in_comm_as_dep_campus_visit',
                    'commitment_rate_never_in_community_campus_visit',
                    'melt_rate_never_in_community_campus_visit',
                    'melt_rate_in_comm_all_campus_visit',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_campus_visit',
                    'yield_rate_not_in_comm_in_comm_as_deposit_campus_visit',
                    'yield_rate_never_in_community_campus_visit',
                    'app_rate_in_comm_in_comm_prior_to_app_campus_visit',
                    'app_rate_not_in_comm_in_comm_as_app_or_after_campus_visit',
                    'app_rate_never_in_community_campus_visit',
                    'inquired_comm_known_race_ethnicity',
                    'applied_comm_known_race_ethnicity',
                    'app_complete_known_race_ethnicity',
                    'accepted_comm_known_race_ethnicity',
                    'committed_comm_known_race_ethnicity',
                    'enrolled_comm_known_race_ethnicity',
                    'inquired_not_in_comm_known_race_ethnicity',
                    'applied_not_in_comm_known_race_ethnicity',
                    'app_complete_not_in_comm_known_race_ethnicity',
                    'accepted_not_in_comm_known_race_ethnicity',
                    'committed_not_in_comm_known_race_ethnicity',
                    'enrolled_not_in_comm_known_race_ethnicity',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_known_race_ethnicity',
                    'commitment_rate_not_in_comm_in_comm_as_dep_known_race_ethnicity',
                    'commitment_rate_never_in_community_known_race_ethnicity',
                    'melt_rate_never_in_community_known_race_ethnicity',
                    'melt_rate_in_comm_all_known_race_ethnicity',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_known_race_ethnicity',
                    'yield_rate_not_in_comm_in_comm_as_deposit_known_race_ethnicity',
                    'yield_rate_never_in_community_known_race_ethnicity',
                    'app_rate_in_comm_in_comm_prior_to_app_known_race_ethnicity',
                    'app_rate_not_in_comm_in_comm_as_app_or_after_known_race_ethnicity',
                    'app_rate_never_in_community_known_race_ethnicity',
                    'inquired_comm_URM_race_ethnicity',
                    'applied_comm_URM_race_ethnicity',
                    'app_complete_URM_race_ethnicity',
                    'accepted_comm_URM_race_ethnicity',
                    'committed_comm_URM_race_ethnicity',
                    'enrolled_comm_URM_race_ethnicity',
                    'inquired_not_in_comm_URM_race_ethnicity',
                    'applied_not_in_comm_URM_race_ethnicity',
                    'app_complete_not_in_comm_URM_race_ethnicity',
                    'accepted_not_in_comm_URM_race_ethnicity',
                    'committed_not_in_comm_URM_race_ethnicity',
                    'enrolled_not_in_comm_URM_race_ethnicity',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_URM_race_ethnicity',
                    'commitment_rate_not_in_comm_in_comm_as_dep_URM_race_ethnicity',
                    'commitment_rate_never_in_community_URM_race_ethnicity',
                    'melt_rate_never_in_community_URM_race_ethnicity',
                    'melt_rate_in_comm_all_URM_race_ethnicity',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_URM_race_ethnicity',
                    'yield_rate_not_in_comm_in_comm_as_deposit_URM_race_ethnicity',
                    'yield_rate_never_in_community_URM_race_ethnicity',
                    'app_rate_in_comm_in_comm_prior_to_app_URM_race_ethnicity',
                    'app_rate_not_in_comm_in_comm_as_app_or_after_URM_race_ethnicity',
                    'app_rate_never_in_community_URM_race_ethnicity',
                    'inquired_comm_Caucasian_race_ethnicity',
                    'applied_comm_Caucasian_race_ethnicity',
                    'app_complete_Caucasian_race_ethnicity',
                    'accepted_comm_Caucasian_race_ethnicity',
                    'committed_comm_Caucasian_race_ethnicity',
                    'enrolled_comm_Caucasian_race_ethnicity',
                    'inquired_not_in_comm_Caucasian_race_ethnicity',
                    'applied_not_in_comm_Caucasian_race_ethnicity',
                    'app_complete_not_in_comm_Caucasian_race_ethnicity',
                    'accepted_not_in_comm_Caucasian_race_ethnicity',
                    'committed_not_in_comm_Caucasian_race_ethnicity',
                    'enrolled_not_in_comm_Caucasian_race_ethnicity',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_Caucasian_race_ethnicity',
                    'commitment_rate_not_in_comm_in_comm_as_dep_Caucasian_race_ethnicity',
                    'commitment_rate_never_in_community_Caucasian_race_ethnicity',
                    'melt_rate_never_in_community_Caucasian_race_ethnicity',
                    'melt_rate_in_comm_all_Caucasian_race_ethnicity',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_Caucasian_race_ethnicity',
                    'yield_rate_not_in_comm_in_comm_as_deposit_Caucasian_race_ethnicity',
                    'yield_rate_never_in_community_Caucasian_race_ethnicity',
                    'app_rate_in_comm_in_comm_prior_to_app_Caucasian_race_ethnicity',
                    'app_rate_not_in_comm_in_comm_as_app_or_after_Caucasian_race_ethnicity',
                    'app_rate_never_in_community_Caucasian_race_ethnicity',
                    'in_comm_asian',
                    'in_comm_american_indian_alaska_native',
                    'in_comm_black_african_american',
                    'in_comm_hispanic_any_race',
                    'in_comm_native_hawaiian_other_pacific',
                    'in_comm_white',
                    'in_comm_nonresident_alien',
                    'in_comm_two_or_more_races',
                    'in_comm_prefer_not_to_respond',
                    'in_comm_race_ethnicity_unknown',
                    'in_comm_applied_asian',
                    'in_comm_applied_american_indian_alaska_native',
                    'in_comm_applied_black_african_american',
                    'in_comm_applied_hispanic_any_race',
                    'in_comm_applied_native_hawaiian_other_pacific',
                    'in_comm_applied_white',
                    'in_comm_applied_nonresident_alien',
                    'in_comm_applied_two_or_more_races',
                    'in_comm_applied_prefer_not_to_respond',
                    'in_comm_applied_race_ethnicity_unknown',
                    'in_comm_accepted_asian',
                    'in_comm_accepted_american_indian_alaska_native',
                    'in_comm_accepted_black_african_american',
                    'in_comm_accepted_hispanic_any_race',
                    'in_comm_accepted_native_hawaiian_other_pacific',
                    'in_comm_accepted_white',
                    'in_comm_accepted_nonresident_alien',
                    'in_comm_accepted_two_or_more_races',
                    'in_comm_accepted_prefer_not_to_respond',
                    'in_comm_accepted_race_ethnicity_unknown',
                    'in_comm_committed_asian',
                    'in_comm_committed_american_indian_alaska_native',
                    'in_comm_committed_black_african_american',
                    'in_comm_committed_hispanic_any_race',
                    'in_comm_committed_native_hawaiian_other_pacific',
                    'in_comm_committed_white',
                    'in_comm_committed_nonresident_alien',
                    'in_comm_committed_two_or_more_races',
                    'in_comm_committed_prefer_not_to_respond',
                    'in_comm_committed_race_ethnicity_unknown',
                    'in_comm_enrolled_asian',
                    'in_comm_enrolled_american_indian_alaska_native',
                    'in_comm_enrolled_black_african_american',
                    'in_comm_enrolled_hispanic_any_race',
                    'in_comm_enrolled_native_hawaiian_other_pacific',
                    'in_comm_enrolled_white',
                    'in_comm_enrolled_nonresident_alien',
                    'in_comm_enrolled_two_or_more_races',
                    'in_comm_enrolled_prefer_not_to_respond',
                    'in_comm_enrolled_race_ethnicity_unknown',
                    'enrolled_community_entered_term_pre_inquired',
                    'enrolled_community_entered_term_inquired',
                    'enrolled_community_entered_term_applied',
                    'enrolled_community_entered_term_app_complete',
                    'enrolled_community_entered_term_accepted',
                    'enrolled_community_entered_term_committed',
                    'committed_community_entered_term_pre_inquired',
                    'committed_community_entered_term_inquired',
                    'committed_community_entered_term_applied',
                    'committed_community_entered_term_app_complete',
                    'committed_community_entered_term_accepted',
                    'committed_community_entered_term_committed',
                    'accepted_community_entered_term_pre_inquired',
                    'accepted_community_entered_term_inquired',
                    'accepted_community_entered_term_applied',
                    'accepted_community_entered_term_app_completed',
                    'accepted_community_entered_term_accepted',
                    'accepted_community_entered_term_committed',
                    'accepted_community_entered_term_stage_missing',
                    'applied_community_entered_term_pre_inquired',
                    'applied_community_entered_term_inquired',
                    'applied_community_entered_term_applied',
                    'applied_community_entered_term_app_complete',
                    'applied_community_entered_term_accepted',
                    'applied_community_entered_term_committed',
                    'applied_community_entered_term_stage_missing',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_non_first_gen',
                    'commitment_rate_never_in_community_non_first_gen',
                    'yield_rate_in_community_regardless_of_join_stage_non_first_gen',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_non_first_gen',
                    'melt_rate_in_community_non_first_gen',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_non_CV',
                    'commitment_rate_never_in_community_non_CV',
                    'yield_rate_in_community_regardless_of_join_stage_non_CV',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_non_CV',
                    'melt_rate_in_community_non_CV',
                    'commitment_rate_in_comm_in_comm_prior_to_deposit_non_URM',
                    'commitment_rate_never_in_community_non_URM',
                    'yield_rate_in_community_regardless_of_join_stage_non_URM',
                    'yield_rate_in_comm_in_comm_prior_to_deposit_non_URM',
                    'melt_rate_in_community_non_URM',
                    'enrolled_community_entered_term_stage_missing',
                    'committed_community_entered_term_stage_missing',
                    'percent_applied_community_entered_term_pre_inquired',
                    'percent_applied_community_entered_term_inquired',
                    'percent_applied_community_entered_term_applied',
                    'percent_applied_community_entered_term_app_complete',
                    'percent_applied_community_entered_term_accepted',
                    'percent_applied_community_entered_term_committed',
                    'percent_applied_community_entered_term_stage_missing',
                    'percent_accepted_community_entered_term_pre_inquired',
                    'percent_accepted_community_entered_term_inquired',
                    'percent_accepted_community_entered_term_applied',
                    'percent_accepted_community_entered_term_app_completed',
                    'percent_accepted_community_entered_term_accepted',
                    'percent_accepted_community_entered_term_committed',
                    'percent_accepted_community_entered_term_stage_missing',
                    'percent_committed_community_entered_term_pre_inquired',
                    'percent_committed_community_entered_term_inquired',
                    'percent_committed_community_entered_term_applied',
                    'percent_committed_community_entered_term_app_complete',
                    'percent_committed_community_entered_term_accepted',
                    'percent_committed_community_entered_term_committed',
                    'percent_committed_community_entered_term_stage_missing',
                    'percent_enrolled_community_entered_term_pre_inquired',
                    'percent_enrolled_community_entered_term_inquired',
                    'percent_enrolled_community_entered_term_applied',
                    'percent_enrolled_community_entered_term_app_complete',
                    'percent_enrolled_community_entered_term_accepted',
                    'percent_enrolled_community_entered_term_committed',
                    'percent_enrolled_community_entered_term_stage_missing'
                      ]
                      
     #data clean-up to load into Redshift
     int_columns = [
          "entry_year",
          "inquired_comm_first_gen",
          "applied_comm_first_gen_",
          "app_complete_comm_first_gen",
          "accepted_comm_first_gen",
          "committed_comm_first_gen",
          "enrolled_comm_first_gen",
          "inquired_not_in_comm_first_gen",
          "applied_not_in_comm_first_gen_",
          "app_complete_not_in_comm_first_gen",
          "accepted_not_in_comm_first_gen",
          "committed_not_in_comm_first_gen",
          "enrolled_not_in_comm_first_gen",
          "inquired_comm_campus_visit",
          "applied_comm_campus_visit",
          "app_complete_comm_campus_visit",
          "accepted_comm_campus_visit",
          "committed_comm_campus_visit",
          "enrolled_comm_campus_visit",
          "inquired_not_in_comm_campus_visit",
          "applied_not_in_comm_campus_visit",
          "app_complete_not_in_comm_campus_visit",
          "accepted_not_in_comm_campus_visit",
          "committed_not_in_comm_campus_visit",
          "enrolled_not_in_comm_campus_visit",
          "inquired_comm_known_race_ethnicity",
          "applied_comm_known_race_ethnicity",
          "app_complete_known_race_ethnicity",
          "accepted_comm_known_race_ethnicity",
          "committed_comm_known_race_ethnicity",
          "enrolled_comm_known_race_ethnicity",
          "inquired_not_in_comm_known_race_ethnicity",
          "applied_not_in_comm_known_race_ethnicity",
          "app_complete_not_in_comm_known_race_ethnicity",
          "accepted_not_in_comm_known_race_ethnicity",
          "committed_not_in_comm_known_race_ethnicity",
          "enrolled_not_in_comm_known_race_ethnicity",
          "inquired_comm_URM_race_ethnicity",
          "applied_comm_URM_race_ethnicity",
          "app_complete_URM_race_ethnicity",
          "accepted_comm_URM_race_ethnicity",
          "committed_comm_URM_race_ethnicity",
          "enrolled_comm_URM_race_ethnicity",
          "inquired_not_in_comm_URM_race_ethnicity",
          "applied_not_in_comm_URM_race_ethnicity",
          "app_complete_not_in_comm_URM_race_ethnicity",
          "accepted_not_in_comm_URM_race_ethnicity",
          "committed_not_in_comm_URM_race_ethnicity",
          "enrolled_not_in_comm_URM_race_ethnicity",
          "inquired_comm_Caucasian_race_ethnicity",
          "applied_comm_Caucasian_race_ethnicity",
          "app_complete_Caucasian_race_ethnicity",
          "accepted_comm_Caucasian_race_ethnicity",
          "committed_comm_Caucasian_race_ethnicity",
          "enrolled_comm_Caucasian_race_ethnicity",
          "inquired_not_in_comm_Caucasian_race_ethnicity",
          "applied_not_in_comm_Caucasian_race_ethnicity",
          "app_complete_not_in_comm_Caucasian_race_ethnicity",
          "accepted_not_in_comm_Caucasian_race_ethnicity",
          "committed_not_in_comm_Caucasian_race_ethnicity",
          "enrolled_not_in_comm_Caucasian_race_ethnicity",
          "in_comm_asian",
          "in_comm_american_indian_alaska_native",
          "in_comm_black_african_american",
          "in_comm_hispanic_any_race",
          "in_comm_native_hawaiian_other_pacific",
          "in_comm_white",
          "in_comm_nonresident_alien",
          "in_comm_two_or_more_races",
          "in_comm_prefer_not_to_respond",
          "in_comm_race_ethnicity_unknown",
          "in_comm_applied_asian",
          "in_comm_applied_american_indian_alaska_native",
          "in_comm_applied_black_african_american",
          "in_comm_applied_hispanic_any_race",
          "in_comm_applied_native_hawaiian_other_pacific",
          "in_comm_applied_white",
          "in_comm_applied_nonresident_alien",
          "in_comm_applied_two_or_more_races",
          "in_comm_applied_prefer_not_to_respond",
          "in_comm_applied_race_ethnicity_unknown",
          "in_comm_accepted_asian",
          "in_comm_accepted_american_indian_alaska_native",
          "in_comm_accepted_black_african_american",
          "in_comm_accepted_hispanic_any_race",
          "in_comm_accepted_native_hawaiian_other_pacific",
          "in_comm_accepted_white",
          "in_comm_accepted_nonresident_alien",
          "in_comm_accepted_two_or_more_races",
          "in_comm_accepted_prefer_not_to_respond",
          "in_comm_accepted_race_ethnicity_unknown",
          "in_comm_committed_asian",
          "in_comm_committed_american_indian_alaska_native",
          "in_comm_committed_black_african_american",
          "in_comm_committed_hispanic_any_race",
          "in_comm_committed_native_hawaiian_other_pacific",
          "in_comm_committed_white",
          "in_comm_committed_nonresident_alien",
          "in_comm_committed_two_or_more_races",
          "in_comm_committed_prefer_not_to_respond",
          "in_comm_committed_race_ethnicity_unknown",
          "in_comm_enrolled_asian",
          "in_comm_enrolled_american_indian_alaska_native",
          "in_comm_enrolled_black_african_american",
          "in_comm_enrolled_hispanic_any_race",
          "in_comm_enrolled_native_hawaiian_other_pacific",
          "in_comm_enrolled_white",
          "in_comm_enrolled_nonresident_alien",
          "in_comm_enrolled_two_or_more_races",
          "in_comm_enrolled_prefer_not_to_respond",
          "in_comm_enrolled_race_ethnicity_unknown",
          "enrolled_community_entered_term_pre_inquired",
          "enrolled_community_entered_term_inquired",
          "enrolled_community_entered_term_applied",
          "enrolled_community_entered_term_app_complete",
          "enrolled_community_entered_term_accepted",
          "enrolled_community_entered_term_committed",
          "committed_community_entered_term_pre_inquired",
          "committed_community_entered_term_inquired",
          "committed_community_entered_term_applied",
          "committed_community_entered_term_app_complete",
          "committed_community_entered_term_accepted",
          "committed_community_entered_term_committed",
          "accepted_community_entered_term_pre_inquired",
          "accepted_community_entered_term_inquired",
          "accepted_community_entered_term_applied",
          "accepted_community_entered_term_app_completed",
          "accepted_community_entered_term_accepted",
          "accepted_community_entered_term_committed",
          "accepted_community_entered_term_stage_missing",
          "applied_community_entered_term_pre_inquired",
          "applied_community_entered_term_inquired",
          "applied_community_entered_term_applied",
          "applied_community_entered_term_app_complete",
          "applied_community_entered_term_accepted",
          "applied_community_entered_term_committed",
          "applied_community_entered_term_stage_missing"
          ]
          
     for col in int_columns:
         for i in range(len(df)):
             df.loc[i, col] = str(df.loc[i, col]).split(".")[0]
     
     df =  df.replace("nan", "") 
     df =  df.fillna("") 
     df = df[column_list]
     df_columns_str = ",".join(df.columns)
     
     print("additional_fields_all_partner_table columns needed:", len(column_list))
     print("columns in df after subsetting-", len(df.columns))
     
     from zeemee_py.helper_functions import send_dataframe_to_s3
     importlib.reload(send_dataframe_to_s3)
     send_dataframe_to_s3.send_dataframe_to_s3(s3_filename_for_update, df)
     
     from zeemee_py.helper_functions import get_config
     accesskeyid, accesskey, bucket_name = get_config.get_creds('accesskeyid', 'accesskey', 'datateams3bucket')
     
     #establishing connection with redshift
     #sys.path.insert(0,'/home/luis/Zemee College_data_project/python_report_projects/helper_functions/')
     from zeemee_py.helper_functions import connect_redshift
     importlib.reload(connect_redshift)
     con = connect_redshift.establish_redshift_connection()
     cur = con.cursor()
     
     
     #create staging table
     create_staging_table = """
          create temp table staging_additional_fields_all_partner_data (
          org_id varchar(80),
          org_name varchar(120),
          entry_year int,
          student_type varchar(45),
          entry_term varchar(45),
          inquired_comm_first_gen int,
          applied_comm_first_gen_ int,
          app_complete_comm_first_gen int,
          accepted_comm_first_gen int,
          committed_comm_first_gen int,
          enrolled_comm_first_gen int,
          inquired_not_in_comm_first_gen int,
          applied_not_in_comm_first_gen_ int,
          app_complete_not_in_comm_first_gen int,
          accepted_not_in_comm_first_gen int,
          committed_not_in_comm_first_gen int,
          enrolled_not_in_comm_first_gen int,
          commitment_rate_in_comm_in_comm_prior_to_deposit_first_gen numeric(6, 4),
          commitment_rate_not_in_comm_in_comm_as_dep_first_gen numeric(6, 4),
          commitment_rate_never_in_community_first_gen numeric(6, 4),
          melt_rate_never_in_community_first_gen numeric(6, 4),
          melt_rate_in_comm_all_first_gen numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_first_gen numeric(6, 4),
          yield_rate_not_in_comm_in_comm_as_deposit_first_gen numeric(6, 4),
          yield_rate_never_in_community_first_gen numeric(6, 4),
          app_rate_in_comm_in_comm_prior_to_app_first_gen numeric(6, 4),
          app_rate_not_in_comm_in_comm_as_app_or_after_first_gen numeric(6, 4),
          app_rate_never_in_community_first_gen numeric(6, 4),
          inquired_comm_campus_visit int,
          applied_comm_campus_visit int,
          app_complete_comm_campus_visit int,
          accepted_comm_campus_visit int,
          committed_comm_campus_visit int,
          enrolled_comm_campus_visit int,
          inquired_not_in_comm_campus_visit int,
          applied_not_in_comm_campus_visit int,
          app_complete_not_in_comm_campus_visit int,
          accepted_not_in_comm_campus_visit int,
          committed_not_in_comm_campus_visit int,
          enrolled_not_in_comm_campus_visit int,
          commitment_rate_in_comm_in_comm_prior_to_deposit_campus_visit numeric(6, 4),
          commitment_rate_not_in_comm_in_comm_as_dep_campus_visit numeric(6, 4),
          commitment_rate_never_in_community_campus_visit numeric(6, 4),
          melt_rate_never_in_community_campus_visit numeric(6, 4),
          melt_rate_in_comm_all_campus_visit numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_campus_visit numeric(6, 4),
          yield_rate_not_in_comm_in_comm_as_deposit_campus_visit numeric(6, 4),
          yield_rate_never_in_community_campus_visit numeric(6, 4),
          app_rate_in_comm_in_comm_prior_to_app_campus_visit numeric(6, 4),
          app_rate_not_in_comm_in_comm_as_app_or_after_campus_visit numeric(6, 4),
          app_rate_never_in_community_campus_visit numeric(6, 4),
          inquired_comm_known_race_ethnicity int,
          applied_comm_known_race_ethnicity int,
          app_complete_known_race_ethnicity int,
          accepted_comm_known_race_ethnicity int,
          committed_comm_known_race_ethnicity int,
          enrolled_comm_known_race_ethnicity int,
          inquired_not_in_comm_known_race_ethnicity int,
          applied_not_in_comm_known_race_ethnicity int,
          app_complete_not_in_comm_known_race_ethnicity int,
          accepted_not_in_comm_known_race_ethnicity int,
          committed_not_in_comm_known_race_ethnicity int,
          enrolled_not_in_comm_known_race_ethnicity int,
          commitment_rate_in_comm_in_comm_prior_to_deposit_known_race_ethnicity numeric(6, 4),
          commitment_rate_not_in_comm_in_comm_as_dep_known_race_ethnicity numeric(6, 4),
          commitment_rate_never_in_community_known_race_ethnicity numeric(6, 4),
          melt_rate_never_in_community_known_race_ethnicity numeric(6, 4),
          melt_rate_in_comm_all_known_race_ethnicity numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_known_race_ethnicity numeric(6, 4),
          yield_rate_not_in_comm_in_comm_as_deposit_known_race_ethnicity numeric(6, 4),
          yield_rate_never_in_community_known_race_ethnicity numeric(6, 4),
          app_rate_in_comm_in_comm_prior_to_app_known_race_ethnicity numeric(6, 4),
          app_rate_not_in_comm_in_comm_as_app_or_after_known_race_ethnicity numeric(6, 4),
          app_rate_never_in_community_known_race_ethnicity numeric(6, 4),
          inquired_comm_URM_race_ethnicity int,
          applied_comm_URM_race_ethnicity int,
          app_complete_URM_race_ethnicity int,
          accepted_comm_URM_race_ethnicity int,
          committed_comm_URM_race_ethnicity int,
          enrolled_comm_URM_race_ethnicity int,
          inquired_not_in_comm_URM_race_ethnicity int,
          applied_not_in_comm_URM_race_ethnicity int,
          app_complete_not_in_comm_URM_race_ethnicity int,
          accepted_not_in_comm_URM_race_ethnicity int,
          committed_not_in_comm_URM_race_ethnicity int,
          enrolled_not_in_comm_URM_race_ethnicity int,
          commitment_rate_in_comm_in_comm_prior_to_deposit_URM_race_ethnicity numeric(6, 4),
          commitment_rate_not_in_comm_in_comm_as_dep_URM_race_ethnicity numeric(6, 4),
          commitment_rate_never_in_community_URM_race_ethnicity numeric(6, 4),
          melt_rate_never_in_community_URM_race_ethnicity numeric(6, 4),
          melt_rate_in_comm_all_URM_race_ethnicity numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_URM_race_ethnicity numeric(6, 4),
          yield_rate_not_in_comm_in_comm_as_deposit_URM_race_ethnicity numeric(6, 4),
          yield_rate_never_in_community_URM_race_ethnicity numeric(6, 4),
          app_rate_in_comm_in_comm_prior_to_app_URM_race_ethnicity numeric(6, 4),
          app_rate_not_in_comm_in_comm_as_app_or_after_URM_race_ethnicity numeric(6, 4),
          app_rate_never_in_community_URM_race_ethnicity numeric(6, 4),
          inquired_comm_Caucasian_race_ethnicity int,
          applied_comm_Caucasian_race_ethnicity int,
          app_complete_Caucasian_race_ethnicity int,
          accepted_comm_Caucasian_race_ethnicity int,
          committed_comm_Caucasian_race_ethnicity int,
          enrolled_comm_Caucasian_race_ethnicity int,
          inquired_not_in_comm_Caucasian_race_ethnicity int,
          applied_not_in_comm_Caucasian_race_ethnicity int,
          app_complete_not_in_comm_Caucasian_race_ethnicity int,
          accepted_not_in_comm_Caucasian_race_ethnicity int,
          committed_not_in_comm_Caucasian_race_ethnicity int,
          enrolled_not_in_comm_Caucasian_race_ethnicity int,
          commitment_rate_in_comm_in_comm_prior_to_deposit_Caucasian_race_ethnicity numeric(6, 4),
          commitment_rate_not_in_comm_in_comm_as_dep_Caucasian_race_ethnicity numeric(6, 4),
          commitment_rate_never_in_community_Caucasian_race_ethnicity numeric(6, 4),
          melt_rate_never_in_community_Caucasian_race_ethnicity numeric(6, 4),
          melt_rate_in_comm_all_Caucasian_race_ethnicity numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_Caucasian_race_ethnicity numeric(6, 4),
          yield_rate_not_in_comm_in_comm_as_deposit_Caucasian_race_ethnicity numeric(6, 4),
          yield_rate_never_in_community_Caucasian_race_ethnicity numeric(6, 4),
          app_rate_in_comm_in_comm_prior_to_app_Caucasian_race_ethnicity numeric(6, 4),
          app_rate_not_in_comm_in_comm_as_app_or_after_Caucasian_race_ethnicity numeric(6, 4),
          app_rate_never_in_community_Caucasian_race_ethnicity numeric(6, 4),
          in_comm_asian int,
          in_comm_american_indian_alaska_native int,
          in_comm_black_african_american int,
          in_comm_hispanic_any_race int,
          in_comm_native_hawaiian_other_pacific int,
          in_comm_white int,
          in_comm_nonresident_alien int,
          in_comm_two_or_more_races int,
          in_comm_prefer_not_to_respond int,
          in_comm_race_ethnicity_unknown int,
          in_comm_applied_asian int,
          in_comm_applied_american_indian_alaska_native int,
          in_comm_applied_black_african_american int,
          in_comm_applied_hispanic_any_race int,
          in_comm_applied_native_hawaiian_other_pacific int,
          in_comm_applied_white int,
          in_comm_applied_nonresident_alien int,
          in_comm_applied_two_or_more_races int,
          in_comm_applied_prefer_not_to_respond int,
          in_comm_applied_race_ethnicity_unknown int,
          in_comm_accepted_asian int,
          in_comm_accepted_american_indian_alaska_native int,
          in_comm_accepted_black_african_american int,
          in_comm_accepted_hispanic_any_race int,
          in_comm_accepted_native_hawaiian_other_pacific int,
          in_comm_accepted_white int,
          in_comm_accepted_nonresident_alien int,
          in_comm_accepted_two_or_more_races int,
          in_comm_accepted_prefer_not_to_respond int,
          in_comm_accepted_race_ethnicity_unknown int,
          in_comm_committed_asian int,
          in_comm_committed_american_indian_alaska_native int,
          in_comm_committed_black_african_american int,
          in_comm_committed_hispanic_any_race int,
          in_comm_committed_native_hawaiian_other_pacific int,
          in_comm_committed_white int,
          in_comm_committed_nonresident_alien int,
          in_comm_committed_two_or_more_races int,
          in_comm_committed_prefer_not_to_respond int,
          in_comm_committed_race_ethnicity_unknown int,
          in_comm_enrolled_asian int,
          in_comm_enrolled_american_indian_alaska_native int,
          in_comm_enrolled_black_african_american int,
          in_comm_enrolled_hispanic_any_race int,
          in_comm_enrolled_native_hawaiian_other_pacific int,
          in_comm_enrolled_white int,
          in_comm_enrolled_nonresident_alien int,
          in_comm_enrolled_two_or_more_races int,
          in_comm_enrolled_prefer_not_to_respond int,
          in_comm_enrolled_race_ethnicity_unknown int,
          enrolled_community_entered_term_pre_inquired int,
          enrolled_community_entered_term_inquired int,
          enrolled_community_entered_term_applied int,
          enrolled_community_entered_term_app_complete int,
          enrolled_community_entered_term_accepted int,
          enrolled_community_entered_term_committed int,
          committed_community_entered_term_pre_inquired int,
          committed_community_entered_term_inquired int,
          committed_community_entered_term_applied int,
          committed_community_entered_term_app_complete int,
          committed_community_entered_term_accepted int,
          committed_community_entered_term_committed int,
          accepted_community_entered_term_pre_inquired int,
          accepted_community_entered_term_inquired int,
          accepted_community_entered_term_applied int,
          accepted_community_entered_term_app_completed int,
          accepted_community_entered_term_accepted int,
          accepted_community_entered_term_committed int,
          accepted_community_entered_term_stage_missing int,
          applied_community_entered_term_pre_inquired int,
          applied_community_entered_term_inquired int,
          applied_community_entered_term_applied int,
          applied_community_entered_term_app_complete int,
          applied_community_entered_term_accepted int,
          applied_community_entered_term_committed int,
          applied_community_entered_term_stage_missing int,
          commitment_rate_in_comm_in_comm_prior_to_deposit_non_first_gen numeric(6, 4),
          commitment_rate_never_in_community_non_first_gen numeric(6, 4),
          yield_rate_in_community_regardless_of_join_stage_non_first_gen numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_non_first_gen numeric(6, 4),
          melt_rate_in_community_non_first_gen numeric(6, 4),
          commitment_rate_in_comm_in_comm_prior_to_deposit_non_CV numeric(6, 4),
          commitment_rate_never_in_community_non_CV numeric(6, 4),
          yield_rate_in_community_regardless_of_join_stage_non_CV numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_non_CV numeric(6, 4),
          melt_rate_in_community_non_CV numeric(6, 4),
          commitment_rate_in_comm_in_comm_prior_to_deposit_non_URM numeric(6, 4),
          commitment_rate_never_in_community_non_URM numeric(6, 4),
          yield_rate_in_community_regardless_of_join_stage_non_URM numeric(6, 4),
          yield_rate_in_comm_in_comm_prior_to_deposit_non_URM numeric(6, 4),
          melt_rate_in_community_non_URM numeric(6, 4),
          enrolled_community_entered_term_stage_missing int,
          committed_community_entered_term_stage_missing int, 
          percent_applied_community_entered_term_pre_inquired numeric(6, 4),
          percent_applied_community_entered_term_inquired numeric(6, 4),
          percent_applied_community_entered_term_applied numeric(6, 4),
          percent_applied_community_entered_term_app_complete numeric(6, 4),
          percent_applied_community_entered_term_accepted numeric(6, 4),
          percent_applied_community_entered_term_committed numeric(6, 4),
          percent_applied_community_entered_term_stage_missing numeric(6, 4),
          percent_accepted_community_entered_term_pre_inquired numeric(6, 4),
          percent_accepted_community_entered_term_inquired numeric(6, 4),
          percent_accepted_community_entered_term_applied numeric(6, 4),
          percent_accepted_community_entered_term_app_completed numeric(6, 4),
          percent_accepted_community_entered_term_accepted numeric(6, 4),
          percent_accepted_community_entered_term_committed numeric(6, 4),
          percent_accepted_community_entered_term_stage_missing numeric(6, 4),
          percent_committed_community_entered_term_pre_inquired numeric(6, 4),
          percent_committed_community_entered_term_inquired numeric(6, 4),
          percent_committed_community_entered_term_applied numeric(6, 4),
          percent_committed_community_entered_term_app_complete numeric(6, 4),
          percent_committed_community_entered_term_accepted numeric(6, 4),
          percent_committed_community_entered_term_committed numeric(6, 4),
          percent_committed_community_entered_term_stage_missing numeric(6, 4),
          percent_enrolled_community_entered_term_pre_inquired numeric(6, 4),
          percent_enrolled_community_entered_term_inquired numeric(6, 4),
          percent_enrolled_community_entered_term_applied numeric(6, 4),
          percent_enrolled_community_entered_term_app_complete numeric(6, 4),
          percent_enrolled_community_entered_term_accepted numeric(6, 4),
          percent_enrolled_community_entered_term_committed numeric(6, 4),
          percent_enrolled_community_entered_term_stage_missing numeric(6, 4)
          )
     """
     cur.execute(create_staging_table)
     con.commit()
     
     print('staging table created')
     
     #copy data from S3 to staging table
     staging_table_copy_command = """
     COPY staging_additional_fields_all_partner_data ({})
     FROM '{}'
     credentials 'aws_access_key_id= {};aws_secret_access_key={}'
     CSV
     NULL 'NaN'
     DATEFORMAT 'YYYY-MM-DD'
     ignoreheader 1;
     """.format(
          df_columns_str,
          s3_filename_for_update,
          accesskeyid,
          accesskey
          )
     cur.execute(staging_table_copy_command)
     con.commit()
     print('copied data to staging table')
     
     #delete rows in actual table which are to be replaced
     delete_rows_to_be_updated = """
     delete from data_team.additional_fields_all_partner_data
     using staging_additional_fields_all_partner_data
     where 
     data_team.additional_fields_all_partner_data.org_id = staging_additional_fields_all_partner_data.org_id
     and data_team.additional_fields_all_partner_data.entry_year = staging_additional_fields_all_partner_data.entry_year
     and data_team.additional_fields_all_partner_data.student_type = staging_additional_fields_all_partner_data.student_type
     and data_team.additional_fields_all_partner_data.entry_term = staging_additional_fields_all_partner_data.entry_term
     """
     cur.execute(delete_rows_to_be_updated)
     con.commit()
     print('rows to be updated deleted from main table')
     
     #insert data from staging table into actual table
     insert_into_table = """
     insert into data_team.additional_fields_all_partner_data
     ({})
     select {} 
     from staging_additional_fields_all_partner_data;
     """.format(df_columns_str,df_columns_str)
     cur.execute(insert_into_table)
     con.commit()
     
     print('copied data to main table from staging')
     
     #drop staging table
     drop_staging_table = """
     drop table staging_additional_fields_all_partner_data
     """
     cur.execute(drop_staging_table)
     con.commit()
     con.close()
     print('staging table dropped')
     
     print('additional_fields_all_partner_data table Redshift update completed')
